package com.loganmagnan.hubcore.listeners;

import com.loganmagnan.hubcore.HubCore;
import com.loganmagnan.hubcore.playerdata.PlayerData;
import org.bukkit.Bukkit;
import org.bukkit.GameMode;
import org.bukkit.Material;
import org.bukkit.block.Block;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.block.BlockPlaceEvent;
import org.bukkit.inventory.ItemStack;

public class BlockPlaceListener implements Listener {

    private HubCore main = HubCore.getInstance();

    @EventHandler
    public void onBlockPlace(BlockPlaceEvent event) {
        Player player = event.getPlayer();

        PlayerData playerData = this.main.getPlayerDataManager().getPlayerData(player.getUniqueId());

        Block block = event.getBlock();

        ItemStack itemStack = new ItemStack(block.getType());

        if (player.getGameMode() == GameMode.CREATIVE) {
            return;
        }

        if (block.getType() == Material.getMaterial(this.main.getHotBarConfig().getConfig().getString("SPAWN.BLOCKS.MATERIAL"))) {
            playerData.getBlocks().add(block);

            Bukkit.getScheduler().scheduleSyncDelayedTask(this.main, new Runnable() {
                @Override
                public void run() {
                    block.setType(Material.AIR);

                    itemStack.setAmount(64);

                    player.getInventory().setItem(main.getHotBarConfig().getConfig().getInt("SPAWN.BLOCKS.SLOT"), itemStack);
                }
            }, 60);

            return;
        }

        event.setCancelled(true);
    }
}
