package com.loganmagnan.hubcore.listeners;

import com.loganmagnan.hubcore.HubCore;
import com.loganmagnan.hubcore.playerdata.PlayerData;
import org.bukkit.Effect;
import org.bukkit.GameMode;
import org.bukkit.Location;
import org.bukkit.Material;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.player.PlayerMoveEvent;
import org.bukkit.plugin.Plugin;

public class PlayerMoveListener implements Listener {

    private HubCore main = HubCore.getInstance();

    @EventHandler
    public void onPlayerMove(PlayerMoveEvent event) {
        Player player = event.getPlayer();

        PlayerData playerData = this.main.getPlayerDataManager().getPlayerData(player.getUniqueId());

        Location location = player.getLocation();

        if (playerData.getEffect() != null) {
            player.playEffect(location, playerData.getEffect(), 50);
        }

        if (location.getY() <= 0) {
            this.main.getPlayerDataManager().sendToSpawnAndResetPlayer(player);
        }

        if (player.getGameMode() != GameMode.CREATIVE && player.getLocation().subtract(0.0, 1.0, 0.0).getBlock().getType() != Material.AIR && !player.isFlying()) {
            player.setAllowFlight(true);
        }

        if (event.getTo().getY() < 2.0) {
            main.getServer().getScheduler().scheduleSyncDelayedTask((Plugin) main, (Runnable) new Runnable() {
                @Override
                public void run() {
                    double y = player.getLocation().getY() - 2.0;
                    Location l = new Location(player.getLocation().getWorld(), player.getLocation().getX(), y, player.getLocation().getZ(), player.getLocation().getYaw(), player.getLocation().getPitch());
                    player.getWorld().playEffect(l, Effect.ENDER_SIGNAL, 50, 30);
                }
            }, 10);
        }
    }
}
