package com.loganmagnan.hubcore.managers.cosmetic;

import com.loganmagnan.hubcore.HubCore;
import com.loganmagnan.hubcore.utils.ColorUtils;
import com.loganmagnan.hubcore.utils.ItemUtil;
import com.loganmagnan.hubcore.utils.config.ConfigCursor;
import lombok.Getter;
import lombok.Setter;
import org.bukkit.Material;

import java.util.ArrayList;
import java.util.List;

@Getter
@Setter
public class CosmeticManager {

    private HubCore main = HubCore.getInstance();

    private ConfigCursor configCursor;

    private List<Cosmetic> cosmetics = new ArrayList<Cosmetic>();

    public CosmeticManager() {
        try {
            this.configCursor = new ConfigCursor(this.main.getCosmeticsConfig(), "COSMETICS");

            for (String hubItem : this.main.getCosmeticsConfig().getConfig().getConfigurationSection("COSMETICS").getKeys(false)) {
                this.cosmetics.add(new Cosmetic(ItemUtil.createUnbreakableItem(
                        Material.valueOf(this.configCursor.getString(hubItem + ".MATERIAL")),
                        ColorUtils.getMessageType(this.configCursor.getString(hubItem + ".NAME")),
                        this.configCursor.getInt(hubItem + ".AMOUNT"),
                        (short) this.configCursor.getInt(hubItem + ".DATA"),
                        this.configCursor.getInt(hubItem + ".CUSTOM-MODEL-DATA")),
                        this.configCursor.getBoolean(hubItem + ".ENABLED"),
                        this.configCursor.getString(hubItem + ".COSMETIC-TYPE"),
                        this.configCursor.getString(hubItem + ".EFFECT"))
                );
            }
        } catch (Exception exception) {
            exception.printStackTrace();
        }
    }

    public Cosmetic getCosmetic(String effect) {
        for (Cosmetic cosmetic : this.cosmetics) {
            if (!cosmetic.getEffect().name().equalsIgnoreCase(effect)) {
                continue;
            }

            return cosmetic;
        }
        return null;
    }
}
