package com.loganmagnan.hubcore.menus;

import com.loganmagnan.hubcore.HubCore;
import com.loganmagnan.hubcore.managers.cosmetic.CosmeticType;
import com.loganmagnan.hubcore.playerdata.PlayerData;
import com.loganmagnan.hubcore.playerdata.PlayerSettings;
import com.loganmagnan.hubcore.menusystem.ItemStackButton;
import com.loganmagnan.hubcore.menusystem.Menu;
import com.loganmagnan.hubcore.menusystem.PlayerMenuUtil;
import com.loganmagnan.hubcore.utils.ColorUtils;
import org.bukkit.Material;
import org.bukkit.entity.Player;
import org.bukkit.event.inventory.InventoryClickEvent;
import org.bukkit.inventory.ItemStack;

public class CosmeticsSelectorMenu extends Menu {

    private HubCore main = HubCore.getInstance();

    public CosmeticsSelectorMenu(PlayerMenuUtil playerMenuUtil) {
        super(playerMenuUtil);
    }

    @Override
    public String getMenuName() {
        return ColorUtils.getMessageType(this.main.getMenusConfig().getConfig().getString("MENUS.COSMETICS-SELECTOR.TITLE"));
    }

    @Override
    public int getSlots() {
        return this.main.getMenusConfig().getConfig().getInt("MENUS.COSMETICS-SELECTOR.SIZE");
    }

    @Override
    public void handleMenu(InventoryClickEvent event) {
        Player player = (Player) event.getWhoClicked();

        PlayerData playerData = this.main.getPlayerDataManager().getPlayerData(player.getUniqueId());

        PlayerSettings playerSettings = playerData.getPlayerSettings();

        if (event.getView().getTitle().equalsIgnoreCase(ColorUtils.getMessageType(this.main.getMenusConfig().getConfig().getString("MENUS.COSMETICS-SELECTOR.TITLE")))) {
            switch (event.getCurrentItem().getType()) {
                case BLAZE_POWDER:
                    new CosmeticTypeMenu(this.playerMenuUtil, CosmeticType.TRAILS).open(player);

                    break;
            }
        }
    }

    @Override
    public void setMenuItems(Player player) {
        PlayerData playerData = this.main.getPlayerDataManager().getPlayerData(player.getUniqueId());

        PlayerSettings playerSettings = playerData.getPlayerSettings();

        this.setFillerGlass();

        ItemStackButton trailsItemStackButton = new ItemStackButton(
                this.main.getMenusConfig().getConfig().getString("MENUS.COSMETICS-SELECTOR.ITEMS.TRAILS.NAME"),
                this.main.getMenusConfig().getConfig().getStringList("MENUS.COSMETICS-SELECTOR.ITEMS.TRAILS.LORE"),
                Material.getMaterial(this.main.getMenusConfig().getConfig().getString("MENUS.COSMETICS-SELECTOR.ITEMS.TRAILS.MATERIAL")),
                0,
                1);

        ItemStack trailsItemStack = trailsItemStackButton.makeItemStack();

        this.inventory.setItem(this.main.getMenusConfig().getConfig().getInt("MENUS.COSMETICS-SELECTOR.ITEMS.TRAILS.SLOT"), trailsItemStack);
    }
}
