package com.loganmagnan.hubcore.playerdata;

import com.loganmagnan.hubcore.HubCore;
import com.loganmagnan.hubcore.managers.PlayerDataManager;
import com.loganmagnan.hubcore.playerdata.currentgame.PlayerCurrentGameData;
import lombok.Getter;
import lombok.Setter;
import org.bukkit.Effect;
import org.bukkit.block.Block;

import java.util.ArrayList;
import java.util.List;
import java.util.UUID;

@Getter
@Setter
public class PlayerData {

    private PlayerDataManager playerDataManager = HubCore.getInstance().getPlayerDataManager();
    private PlayerState playerState = PlayerState.SPAWN;

    private PlayerSettings playerSettings = new PlayerSettings();
    private PlayerCurrentGameData currentGameData = new PlayerCurrentGameData();

    private final UUID uniqueId;
    private boolean loaded;

    private List<Block> blocks = new ArrayList<Block>();

    private Effect effect;

    public PlayerData(UUID uniqueId) {
        this.uniqueId = uniqueId;
        this.loaded = false;
        this.playerDataManager.loadPlayerData(this);
    }

    public boolean isInSpawn() {
        return this.playerState == PlayerState.SPAWN;
    }
}
